`line 1 "\\Athron\verilog\gpio\gpio\rtl\verilog\gpio_top.v"








































































































`line 1 "\\Athron\verilog\gpio\gpio\bench\verilog\timescale.v"
`timescale 1ns/10ps

`line 105 "\\Athron\verilog\gpio\gpio\rtl\verilog\gpio_top.v"


`line 1 "\\Athron\verilog\gpio\gpio\rtl\verilog\gpio_defines.v"






























































































































































































































































`line 107 "\\Athron\verilog\gpio\gpio\rtl\verilog\gpio_top.v"


module gpio_top(
	
	wb_clk_i, wb_rst_i, wb_cyc_i, wb_adr_i, wb_dat_i, wb_sel_i, wb_we_i, wb_stb_i,
	wb_dat_o, wb_ack_o, wb_err_o, wb_inta_o,

	
	aux_i,

	
	ext_pad_i, clk_pad_i, ext_pad_o, ext_padoen_o
);

parameter dw = 32;
parameter aw =  6+1;
parameter gw =  31;



input			wb_clk_i;	
input			wb_rst_i;	
input			wb_cyc_i;	
input 	[aw-1:0]	wb_adr_i;	
input	[dw-1:0]	wb_dat_i;	
input	[3:0]		wb_sel_i;	
input			wb_we_i;	
input			wb_stb_i;	
output	[dw-1:0]	wb_dat_o;	
output			wb_ack_o;	
output			wb_err_o;	
output			wb_inta_o;	


input	[gw-1:0]	aux_i;		




input	[gw-1:0]	ext_pad_i;	
input			clk_pad_i;	
output	[gw-1:0]	ext_pad_o;	
output	[gw-1:0]	ext_padoen_o;	







reg	[gw-1:0]	rgpio_in;	








reg	[gw-1:0]	rgpio_out;	








reg	[gw-1:0]	rgpio_oe;	








reg	[gw-1:0]	rgpio_inte;	








reg	[gw-1:0]	rgpio_ptrig;	








reg	[gw-1:0]	rgpio_aux;	








reg	[3:0]		rgpio_ctrl;	








reg	[gw-1:0]	rgpio_ints;	







wire			rgpio_out_sel;	
wire			rgpio_oe_sel;	
wire			rgpio_inte_sel;	
wire			rgpio_ptrig_sel;
wire			rgpio_aux_sel;	
wire			rgpio_ctrl_sel;	
wire			rgpio_ints_sel;	
wire			latch_clk;	
wire			full_decoding;	
wire	[gw-1:0]	in_muxed;	
wire			wb_ack;		
wire			wb_err;		
wire			wb_inta;	
reg	[dw-1:0]	wb_dat;		

reg			wb_ack_o;	
reg			wb_err_o;	
reg			wb_inta_o;	
reg	[dw-1:0]	wb_dat_o;	

wire	[gw-1:0]	out_pad;	

reg	[gw-1:0]	ext_pad_o;	

wire	[gw-1:0]	extc_in;	
wire			pext_clk;	
reg	[gw-1:0]	pextc_sampled;	


reg	[gw-1:0]	nextc_sampled;	












assign wb_ack = wb_cyc_i & wb_stb_i & !wb_err_o;





always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		wb_ack_o <= #1 1'b0;
	else
		wb_ack_o <= #1 wb_ack & ~wb_ack_o & (!wb_err) ;











assign wb_err = wb_cyc_i & wb_stb_i & !full_decoding;













always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		wb_err_o <= #1 1'b0;
	else
		wb_err_o <= #1 wb_err & ~wb_err_o;








assign full_decoding = (wb_adr_i[ 6: 5] == { 6- 5+1{1'b0}}) &
			(wb_adr_i[ 1: 0] == { 1- 0+1{1'b0}});







assign rgpio_out_sel = wb_cyc_i & wb_stb_i & (wb_adr_i[  5 - 1 :  1 + 1] ==  3'h1) & full_decoding;
assign rgpio_oe_sel = wb_cyc_i & wb_stb_i & (wb_adr_i[  5 - 1 :  1 + 1] ==  3'h2) & full_decoding;
assign rgpio_inte_sel = wb_cyc_i & wb_stb_i & (wb_adr_i[  5 - 1 :  1 + 1] ==  3'h3) & full_decoding;
assign rgpio_ptrig_sel = wb_cyc_i & wb_stb_i & (wb_adr_i[  5 - 1 :  1 + 1] ==  3'h4) & full_decoding;
assign rgpio_aux_sel = wb_cyc_i & wb_stb_i & (wb_adr_i[  5 - 1 :  1 + 1] ==  3'h5) & full_decoding;
assign rgpio_ctrl_sel = wb_cyc_i & wb_stb_i & (wb_adr_i[  5 - 1 :  1 + 1] ==  3'h6) & full_decoding;
assign rgpio_ints_sel = wb_cyc_i & wb_stb_i & (wb_adr_i[  5 - 1 :  1 + 1] ==  3'h7) & full_decoding;





always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		rgpio_ctrl <= #1 4'b0;
	else if (rgpio_ctrl_sel && wb_we_i)
		rgpio_ctrl <= #1 wb_dat_i[3:0];
	else if (rgpio_ctrl[ 2])
		rgpio_ctrl[ 3] <= #1 rgpio_ctrl[ 3] | wb_inta_o;








always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		rgpio_out <= #1 {gw{1'b0}};
	else if (rgpio_out_sel && wb_we_i)
    begin





     if ( wb_sel_i [3] == 1'b1 )
       rgpio_out [gw-1:24] <= #1 wb_dat_i [gw-1:24] ;
     if ( wb_sel_i [2] == 1'b1 )
       rgpio_out [23:16] <= #1 wb_dat_i [23:16] ;
     if ( wb_sel_i [1] == 1'b1 )
       rgpio_out [15:8] <= #1 wb_dat_i [15:8] ;
     if ( wb_sel_i [0] == 1'b1 )
       rgpio_out [7:0] <= #1 wb_dat_i [7:0] ;



















   end









always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		rgpio_oe <= #1 {gw{1'b0}};
	else if (rgpio_oe_sel && wb_we_i)
  begin





     if ( wb_sel_i [3] == 1'b1 )
       rgpio_oe [gw-1:24] <= #1 ~wb_dat_i [gw-1:24] ;
     if ( wb_sel_i [2] == 1'b1 )
       rgpio_oe [23:16] <= #1 ~wb_dat_i [23:16] ;
     if ( wb_sel_i [1] == 1'b1 )
       rgpio_oe [15:8] <= #1 ~wb_dat_i [15:8] ;
     if ( wb_sel_i [0] == 1'b1 )
       rgpio_oe [7:0] <= #1 ~wb_dat_i [7:0] ;



















   end









always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		rgpio_inte <= #1 {gw{1'b0}};
	else if (rgpio_inte_sel && wb_we_i)
  begin





     if ( wb_sel_i [3] == 1'b1 )
       rgpio_inte [gw-1:24] <= #1 wb_dat_i [gw-1:24] ;
     if ( wb_sel_i [2] == 1'b1 )
       rgpio_inte [23:16] <= #1 wb_dat_i [23:16] ;
     if ( wb_sel_i [1] == 1'b1 )
       rgpio_inte [15:8] <= #1 wb_dat_i [15:8] ;
     if ( wb_sel_i [0] == 1'b1 )
       rgpio_inte [7:0] <= #1 wb_dat_i [7:0] ;



















   end










always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		rgpio_ptrig <= #1 {gw{1'b0}};
	else if (rgpio_ptrig_sel && wb_we_i)
  begin





     if ( wb_sel_i [3] == 1'b1 )
       rgpio_ptrig [gw-1:24] <= #1 wb_dat_i [gw-1:24] ;
     if ( wb_sel_i [2] == 1'b1 )
       rgpio_ptrig [23:16] <= #1 wb_dat_i [23:16] ;
     if ( wb_sel_i [1] == 1'b1 )
       rgpio_ptrig [15:8] <= #1 wb_dat_i [15:8] ;
     if ( wb_sel_i [0] == 1'b1 )
       rgpio_ptrig [7:0] <= #1 wb_dat_i [7:0] ;



















   end
    








always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		rgpio_aux <= #1 {gw{1'b0}};
	else if (rgpio_aux_sel && wb_we_i)
  begin





     if ( wb_sel_i [3] == 1'b1 )
       rgpio_aux [gw-1:24] <= #1 wb_dat_i [gw-1:24] ;
     if ( wb_sel_i [2] == 1'b1 )
       rgpio_aux [23:16] <= #1 wb_dat_i [23:16] ;
     if ( wb_sel_i [1] == 1'b1 )
       rgpio_aux [15:8] <= #1 wb_dat_i [15:8] ;
     if ( wb_sel_i [0] == 1'b1 )
       rgpio_aux [7:0] <= #1 wb_dat_i [7:0] ;



















   end









always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		rgpio_in <= #1 {gw{1'b0}};
	else
		rgpio_in <= #1 in_muxed;







assign in_muxed = rgpio_ctrl[ 0] ? extc_in : ext_pad_i;












assign pext_clk = clk_pad_i;








assign extc_in = rgpio_ctrl[ 1] ? nextc_sampled : pextc_sampled;





always @(posedge pext_clk or posedge wb_rst_i)
	if (wb_rst_i)
		pextc_sampled <= #1 {gw{1'b0}};
	else
		pextc_sampled <= #1 ext_pad_i;






always @(negedge clk_pad_i or posedge wb_rst_i)
	if (wb_rst_i)
		nextc_sampled <= #1 {gw{1'b0}};
	else
		nextc_sampled <= #1 ext_pad_i;





always @(wb_adr_i or rgpio_in or rgpio_out or rgpio_oe or rgpio_inte or
		rgpio_ptrig or rgpio_aux or rgpio_ctrl or rgpio_ints)
	case (wb_adr_i[  5 - 1 :  1 + 1])	

		 3'h1: begin
			wb_dat[dw-1:0] = rgpio_out;
		end
		 3'h2: begin
			wb_dat[dw-1:0] = ~rgpio_oe;
		end
		 3'h3: begin
			wb_dat[dw-1:0] = rgpio_inte;
		end
		 3'h4: begin
			wb_dat[dw-1:0] = rgpio_ptrig;
		end
		 3'h5: begin
			wb_dat[dw-1:0] = rgpio_aux;
		end
		 3'h6: begin
			wb_dat[3:0] = rgpio_ctrl;
			wb_dat[dw-1:4] = {dw-4{1'b0}};
		end

		 3'h7: begin
			wb_dat[dw-1:0] = rgpio_ints;
		end
		default: begin
			wb_dat[dw-1:0] = rgpio_in;
		end
	endcase





always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		wb_dat_o <= #1 {dw{1'b0}};
	else
		wb_dat_o <= #1 wb_dat;








always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		rgpio_ints <= #1 {gw{1'b0}};
	else if (rgpio_ints_sel && wb_we_i)
		rgpio_ints <= #1 wb_dat_i[gw-1:0];
	else if (rgpio_ctrl[ 2])
		rgpio_ints <= #1 (rgpio_ints | ((ext_pad_i ^ rgpio_in) & ~(ext_pad_i ^ rgpio_ptrig)) & rgpio_inte);







assign wb_inta = |rgpio_ints ? rgpio_ctrl[ 2] : 1'b0;





always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		wb_inta_o <= #1 1'b0;
	else
		wb_inta_o <= #1 wb_inta;







assign ext_padoen_o = rgpio_oe;




assign out_pad = rgpio_out & ~rgpio_aux | aux_i & rgpio_aux;





always @(posedge wb_clk_i or posedge wb_rst_i)
	if (wb_rst_i)
		ext_pad_o <= #1 {gw{1'b0}};
	else
		ext_pad_o <= #1 out_pad;























endmodule


`line 1 "\\Athron\verilog\gpio\gpio\rtl\verilog\gpio_defines.v"































































































































































































































































`line 1 "\\Athron\verilog\gpio\gpio\bench\verilog\wb_master.v"
`line 1 "\\Athron\verilog\gpio\gpio\bench\verilog\timescale.v"
`timescale 1ns/10ps

`line 1 "\\Athron\verilog\gpio\gpio\bench\verilog\wb_master.v"

`line 1 "\\Athron\verilog\gpio\gpio\rtl\verilog\gpio_defines.v"






























































































































































































































































`line 2 "\\Athron\verilog\gpio\gpio\bench\verilog\wb_master.v"
























module wb_master(CLK_I, RST_I, TAG_I, TAG_O,
		   ACK_I, ADR_O, CYC_O, DAT_I, DAT_O, ERR_I, RTY_I, SEL_O, STB_O, WE_O);

parameter aw =  6+1 ;
   input		CLK_I;
   input		RST_I;
   input [3:0] 		TAG_I;
   output [3:0] 	TAG_O;
   input		ACK_I;
   output [aw-1:0] 	ADR_O;
   output		CYC_O;
   input [31:0] 	DAT_I;
   output [31:0] 	DAT_O;
   input		ERR_I;
   input		RTY_I;
   output [3:0] 	SEL_O;
   output		STB_O;
   output		WE_O;
   
   reg [aw-1:0] 		ADR_O;
   reg [3:0] 		SEL_O;
   reg 			CYC_O;
   reg 			STB_O;
   reg 			WE_O;
   reg [31:0] 		DAT_O;
   
   wire [15:0] 		mem_sizes;      
   reg [31:0] 		write_burst_buffer[0:7];
   reg [31:0] 		read_burst_buffer[0:7];
   
   reg 			GO;
   integer 		cycle_end;
   integer 		address; 		
   integer 		data;
   integer 		selects;
   integer 		write_flag;
   
   
   
   
   
   
   
   
   
   
   
   
   
   assign 		mem_sizes = 16'b10_01_10_11_00_01_10_11;

   function [1:0] data_width;
      input [31:0] adr;
      begin
	 casex (adr[31:29])
	   3'b000: data_width = mem_sizes[15:14];
	   3'b001: data_width = mem_sizes[13:12];
	   3'b010: data_width = mem_sizes[11:10];
	   3'b011: data_width = mem_sizes[9:8];
	   3'b100: data_width = mem_sizes[7:6];
	   3'b101: data_width = mem_sizes[5:4];
	   3'b110: data_width = mem_sizes[3:2];
	   3'b111: data_width = mem_sizes[1:0];
	   3'bxxx: data_width = 2'bxx;
	 endcase 
      end
   endfunction
      
   always @(posedge CLK_I or posedge RST_I)
     begin
	if (RST_I)
	  begin
	     GO = 1'b0;
	  end
     end
   
   
   task rd;
      input [31:0] adr;
      output [31:0] result;
      
      begin
	 cycle_end = 1;
	 address = adr;
	 selects = 255;
	 write_flag = 0;
	 
	 GO <= 1;	 
	 @(posedge CLK_I);


	 
	 while (~CYC_O)
	   @(posedge CLK_I);

	 
	 while (CYC_O)
	   @(posedge CLK_I);

	 result = data;

	 
      end
   endtask 
   
   task wr;
      input [31:0] adr;
      input [31:0] dat;
      input [3:0] sel;
      begin
	 cycle_end = 1;
	 address = adr;
	 selects = sel;
	 write_flag = 1;
	 data = dat;
	 
	 GO <= 1;	 
	 @(posedge CLK_I);


	 
	 while (~CYC_O)
	   @(posedge CLK_I);

	 
	 while (CYC_O)
	   @(posedge CLK_I);


      end
   endtask 

   
   task blkrd;
      input [31:0] adr;
      input end_flag;
      output [31:0] result;
      
      begin
	 write_flag = 0;
	 cycle_end = end_flag;
	 address = adr;	 
	 GO <= 1;	 
	 @(posedge CLK_I);


	 while (~(ACK_I & STB_O))
	   @(posedge CLK_I);
	 
	 result = data;
      end
   endtask 

   
   task blkwr;
      input [31:0] adr;
      input [31:0] dat;
      input [3:0] sel;
      input end_flag;
      begin
	 write_flag = 1;
	 cycle_end = end_flag;
	 address = adr;	 
	 data = dat;
	 selects = sel;
	 GO <= 1;	 
	 @(posedge CLK_I);


	 while (~(ACK_I & STB_O))
	   @(posedge CLK_I);
	 
      end
   endtask 

   
   task rmw;
      input [31:0] adr;
      input [31:0] dat;
      input [3:0] sel;
      output [31:0] result;
      
      begin
	 
	 write_flag = 0;
	 cycle_end = 0;
	 address = adr;	 
	 GO <= 1;	 
	 @(posedge CLK_I);


	 while (~(ACK_I & STB_O))
	   @(posedge CLK_I);
	 
	 result = data;

	 
	 write_flag = 1;
	 address = adr;	 
	 selects = sel;
	 GO <= 1;	 
	 data <= dat;
	 cycle_end <= 1;
	 @(posedge CLK_I);


	 while (~(ACK_I & STB_O))
	   @(posedge CLK_I);
	 
      end      
   endtask 
   
   always @(posedge CLK_I)
     begin
	if (RST_I)
	  ADR_O <= 32'h0000_0000;
	else
	  ADR_O <= address;	
     end
   
   always @(posedge CLK_I)
     begin
	if (RST_I | ERR_I | RTY_I)
	  CYC_O <= 1'b0;
	else if ((cycle_end == 1) & ACK_I)
	  CYC_O <= 1'b0;
	else if (GO | CYC_O) begin
	  CYC_O <= 1'b1;
	  GO <= 1'b0;
        end
     end

   
   always @(posedge CLK_I)
     begin
	if (RST_I | ERR_I | RTY_I)
	  STB_O <= 1'b0;
	else if (STB_O & ACK_I)
	  STB_O <= 1'b0;
	else if (GO | STB_O)
	  STB_O <= 1'b1;
     end

   
   always @(posedge CLK_I)
     begin
	if (write_flag == 0) begin
	   SEL_O <= 4'b1111;
	   if (STB_O & ACK_I)
	     data <= DAT_I;	   
	end
	else begin
	   case (data_width(address))
	     2'b00: begin
		SEL_O <= {3'b000, selects[0]};
		DAT_O <= {data[7:0], data[7:0], data[7:0], data[7:0]};
	     end
	     2'b01: begin
		SEL_O <= {2'b00, selects[1:0]};
		DAT_O <= {data[15:0], data[15:0]};
	     end
	     2'b10: begin
		SEL_O <= selects;
		DAT_O <= data;
	     end
	   endcase
	end
     end

   always @(posedge CLK_I)
     begin
	if (RST_I)
	  WE_O <= 1'b0;
	else if (GO)
	  WE_O <= write_flag;
     end
   
endmodule







`line 1 "\\Athron\verilog\gpio\gpio\bench\verilog\clkrst.v"






















































`line 1 "\\Athron\verilog\gpio\gpio\bench\verilog\timescale.v"
`timescale 1ns/10ps

`line 55 "\\Athron\verilog\gpio\gpio\bench\verilog\clkrst.v"


module clkrst(clk_o, rst_o);




output	clk_o;	
output	rst_o;	




reg	clk_o;	
reg	rst_o;	

initial begin
	clk_o = 0;
	rst_o = 1;
	#20;
	rst_o = 0;
end




always #4 clk_o = ~clk_o;

endmodule


`line 1 "\\Athron\verilog\gpio\gpio\bench\verilog\gpio_mon.v"




























































`line 1 "\\Athron\verilog\gpio\gpio\bench\verilog\timescale.v"
`timescale 1ns/10ps

`line 61 "\\Athron\verilog\gpio\gpio\bench\verilog\gpio_mon.v"

`line 1 "\\Athron\verilog\gpio\gpio\rtl\verilog\gpio_defines.v"






























































































































































































































































`line 62 "\\Athron\verilog\gpio\gpio\bench\verilog\gpio_mon.v"


module gpio_mon(gpio_aux, gpio_in, gpio_eclk, gpio_out, gpio_oen);

parameter gw =  31;




output	[gw-1:0]	gpio_aux;	
output	[gw-1:0]	gpio_in;	
output			gpio_eclk;	
input	[gw-1:0]	gpio_out;	
input	[gw-1:0]	gpio_oen;	




reg	[gw-1:0]	gpio_aux;
reg	[gw-1:0]	gpio_in;
reg			gpio_eclk;

initial gpio_eclk = 0;




task set_gpioin;
input	[31:0]	val;
begin
	gpio_in = val;
end
endtask




task set_gpioaux;
input	[31:0]	val;
begin
	gpio_aux = val;
end
endtask




task set_gpioeclk;
input	[31:0]	val;
begin
	gpio_eclk = val[0];
end
endtask





task get_gpioout;
output	[31:0]	val;
reg	[31:0]	val;
begin
	val = gpio_out;
end
endtask




task get_gpiooen;
output	[31:0]	val;
begin
	val = gpio_oen;
end
endtask

endmodule


`line 1 "\\Athron\verilog\gpio\gpio\bench\verilog\gpio_testbench.v"








































































`line 1 "\\Athron\verilog\gpio\gpio\bench\verilog\timescale.v"
`timescale 1ns/10ps

`line 73 "\\Athron\verilog\gpio\gpio\bench\verilog\gpio_testbench.v"

`line 1 "\\Athron\verilog\gpio\gpio\rtl\verilog\gpio_defines.v"






























































































































































































































































`line 74 "\\Athron\verilog\gpio\gpio\bench\verilog\gpio_testbench.v"


module gpio_testbench();

parameter aw =  6+1 ;
parameter dw = 32;
parameter gw =  31;




wire			clk;	
wire			rst;	
wire			cyc;	
wire	[aw-1:0]	adr;	
wire	[dw-1:0]	dat_m;	
wire	[3:0]		sel;	
wire			we;	
wire			stb;	
wire	[dw-1:0]	dat_ptc;
wire			ack;	
wire			err;	
wire	[gw-1:0]	gpio_aux;	
wire	[gw-1:0]	gpio_in;	
wire			gpio_eclk;	
wire	[gw-1:0]	gpio_out;	
wire	[gw-1:0]	gpio_oen;	
wire [ 3 : 0 ] tag_o ;




clkrst clkrst(
	
	.clk_o(clk),
	
	.rst_o(rst)
);




wb_master wb_master(
	
	.CLK_I(clk),
	.RST_I(rst),
	.CYC_O(cyc),
	.ADR_O(adr),
	.DAT_O(dat_ptc),
	.SEL_O(sel),
	.WE_O(we),
	.STB_O(stb),
	.DAT_I(dat_m),
	.ACK_I(ack),
	.ERR_I(err),
	.RTY_I(1'b0),
	.TAG_I(4'b0),
  .TAG_O ( tag_o ) 
);




gpio_top gpio_top(
	
	.wb_clk_i(clk),
	.wb_rst_i(rst),
	.wb_cyc_i(cyc),
	.wb_adr_i(adr),
	.wb_dat_i(dat_ptc),
	.wb_sel_i(sel),
	.wb_we_i(we),
	.wb_stb_i(stb),
	.wb_dat_o(dat_m),
	.wb_ack_o(ack),
	.wb_err_o(err),
	.wb_inta_o(),

	
	.aux_i(gpio_aux),

	
	.ext_pad_i(gpio_in),
	.clk_pad_i(gpio_eclk),
	.ext_pad_o(gpio_out),
	.ext_padoen_o(gpio_oen)
);




gpio_mon gpio_mon(
	.gpio_aux(gpio_aux),
	.gpio_in(gpio_in),
	.gpio_eclk(gpio_eclk),
	.gpio_out(gpio_out),
	.gpio_oen(gpio_oen)
);

endmodule


`line 1 "\\Athron\verilog\gpio\gpio\bench\verilog\tb_defines.v"

















































































`line 1 "\\Athron\verilog\gpio\gpio\bench\verilog\tb_tasks.v"

















































































`line 1 "\\Athron\verilog\gpio\gpio\bench\verilog\timescale.v"
`timescale 1ns/10ps

`line 82 "\\Athron\verilog\gpio\gpio\bench\verilog\tb_tasks.v"

`line 1 "\\Athron\verilog\gpio\gpio\rtl\verilog\gpio_defines.v"






























































































































































































































































`line 83 "\\Athron\verilog\gpio\gpio\bench\verilog\tb_tasks.v"

`line 1 "\\Athron\verilog\gpio\gpio\bench\verilog\tb_defines.v"
















































































`line 84 "\\Athron\verilog\gpio\gpio\bench\verilog\tb_tasks.v"


module tb_tasks;

integer nr_failed;
integer ints_disabled;
integer ints_working;
integer local_errs;

parameter sh_addr =  1+1;
parameter gw =  31 ;



task failed;
begin
	$display("FAILED !!!");
	nr_failed = nr_failed + 1;
end
endtask




task setout;
input	[31:0] val;

reg  [ 31:0 ] addr ;
begin
  addr =  3'h1 <<sh_addr ;
	#100 gpio_testbench.wb_master.wr( 3'h1<<sh_addr, val, 4'b1111);






end

endtask




task setoe;
input	[31:0] val;

begin
	#100 gpio_testbench.wb_master.wr( 3'h2<<sh_addr, val, 4'b1111);
end

endtask




task setinte;
input	[31:0] val;

begin
	#100 gpio_testbench.wb_master.wr( 3'h3<<sh_addr, val, 4'b1111);
end

endtask




task setptrig;
input	[31:0] val;

begin
	#100 gpio_testbench.wb_master.wr( 3'h4<<sh_addr, val, 4'b1111);
end

endtask




task setaux;
input	[31:0] val;

begin
	#100 gpio_testbench.wb_master.wr( 3'h5<<sh_addr, val, 4'b1111);
end

endtask




task setctrl;
input	[31:0] val;

begin
	#100 gpio_testbench.wb_master.wr( 3'h6<<sh_addr, val, 4'b1111);
end

endtask




task setints;
input	[31:0] val;

begin
	#100 gpio_testbench.wb_master.wr( 3'h7<<sh_addr, val, 4'b1111);
end

endtask




task showin;

reg	[31:0] tmp;
begin
	#100 gpio_testbench.wb_master.rd( 3'h0<<sh_addr, tmp);
	$write(" RGPIO_IN: %h", tmp);
end

endtask




task showout;

reg	[31:0] tmp;
begin
	#100 gpio_testbench.wb_master.rd( 3'h1<<sh_addr, tmp);
	$write(" RGPIO_OUT: %h", tmp);
end

endtask





task showoe;

reg	[31:0] tmp;
begin
	#100 gpio_testbench.wb_master.rd( 3'h2<<sh_addr, tmp);
	$write(" RGPIO_OE:%h", tmp);
end

endtask




task showinte;

reg	[31:0] tmp;
begin
	#100 gpio_testbench.wb_master.rd( 3'h3<<sh_addr, tmp);
	$write(" RGPIO_INTE:%h", tmp);
end

endtask




task showptrig;

reg	[31:0] tmp;
begin
	#100 gpio_testbench.wb_master.rd( 3'h4<<sh_addr, tmp);
	$write(" RGPIO_PTRIG:%h", tmp);
end

endtask




task showaux;

reg	[31:0] tmp;
begin
	#100 gpio_testbench.wb_master.rd( 3'h5<<sh_addr, tmp);
	$write(" RGPIO_AUX:%h", tmp);
end

endtask




task showctrl;

reg	[31:0] tmp;
begin
	#100 gpio_testbench.wb_master.rd( 3'h6<<sh_addr, tmp);
	$write(" RGPIO_CTRL: %h", tmp);
end

endtask




task showints;

reg	[31:0] tmp;
begin
	#100 gpio_testbench.wb_master.rd( 3'h7<<sh_addr, tmp);
	$write(" RGPIO_INTS:%h", tmp);
end

endtask




task comp_in;
input	[31:0] 	val;
output		ret;

reg	[31:0]	tmp;
reg		ret;
begin
	#100 gpio_testbench.wb_master.rd( 3'h0<<sh_addr, tmp);

	if (tmp == val)
		ret = 1;
	else
		ret = 0;
end

endtask




task getin;
output	[31:0]	tmp;

begin
	#100 gpio_testbench.wb_master.rd( 3'h0<<sh_addr, tmp);
end

endtask




task getout;
output	[31:0]	tmp;

begin
	#100 gpio_testbench.wb_master.rd( 3'h1<<sh_addr, tmp);
end

endtask




task getoe;
output	[31:0]	tmp;

begin
	#100 gpio_testbench.wb_master.rd( 3'h2<<sh_addr, tmp);
end

endtask




task getinte;
output	[31:0]	tmp;

begin
	#100 gpio_testbench.wb_master.rd( 3'h3<<sh_addr, tmp);
end

endtask




task getptrig;
output	[31:0]	tmp;

begin
	#100 gpio_testbench.wb_master.rd( 3'h4<<sh_addr, tmp);
end

endtask




task getaux;
output	[31:0]	tmp;

begin
	#100 gpio_testbench.wb_master.rd( 3'h5<<sh_addr, tmp);
end

endtask




task getctrl;
output	[31:0]	tmp;

begin
	#100 gpio_testbench.wb_master.rd( 3'h6<<sh_addr, tmp);
end

endtask




task getints;
output	[31:0]	tmp;

begin
	#100 gpio_testbench.wb_master.rd( 3'h7<<sh_addr, tmp);
end

endtask




task random_gpio;
output	[31:0]	tmp;

begin
	tmp = $random & ((1<< 31)-1);
end

endtask




task test_eclk;
reg [gw-1:0 ]		l1, l2, l3;
reg [gw-1:0 ]		r1, r2, r3;
begin

	
	gpio_testbench.gpio_mon.set_gpioeclk(0);
	@(posedge gpio_testbench.clk);
	@(posedge gpio_testbench.clk);

	
	
	
	
	

	
	random_gpio(r1);
	gpio_testbench.gpio_mon.set_gpioin(r1);

	
	setctrl(0);

	
	@(posedge gpio_testbench.clk);
	@(posedge gpio_testbench.clk);

	
	getin(l1);

	
	
	
	
	

	
	setctrl(1 <<  0);

	
	random_gpio(r2);
	gpio_testbench.gpio_mon.set_gpioin(r2);

	
	gpio_testbench.gpio_mon.set_gpioeclk(0);
	@(posedge gpio_testbench.clk);
	@(posedge gpio_testbench.clk);
	gpio_testbench.gpio_mon.set_gpioeclk(1);
	@(posedge gpio_testbench.clk);
	@(posedge gpio_testbench.clk);

	
	getin(l2);

	
	
	
	
	
	

	
	random_gpio(r3);
	gpio_testbench.gpio_mon.set_gpioin(r3);

	
	@(posedge gpio_testbench.clk);
	@(posedge gpio_testbench.clk);

	
	getin(l3);

	
	
	
	
	
	if (l1 == r1 && l2 == r2 && l2 == l3)
		$write(".");
	else
		local_errs = local_errs + 1;
end
endtask




task test_nec;
integer		l1, l2;
integer		r1, r2;
begin
	
	
	
	
	

	
	gpio_testbench.gpio_mon.set_gpioeclk(0);
	@(posedge gpio_testbench.clk);
	@(posedge gpio_testbench.clk);

	
	setctrl(1 <<  0 | 1 <<  1);

	
	random_gpio(r1);
	gpio_testbench.gpio_mon.set_gpioin(r1);

	
	gpio_testbench.gpio_mon.set_gpioeclk(1);
	@(posedge gpio_testbench.clk);
	@(posedge gpio_testbench.clk);
	gpio_testbench.gpio_mon.set_gpioeclk(0);
	@(posedge gpio_testbench.clk);
	@(posedge gpio_testbench.clk);

	
	random_gpio(r2);
	gpio_testbench.gpio_mon.set_gpioin(r2);

	
	gpio_testbench.gpio_mon.set_gpioeclk(0);
	@(posedge gpio_testbench.clk);
	@(posedge gpio_testbench.clk);
	gpio_testbench.gpio_mon.set_gpioeclk(1);
	@(posedge gpio_testbench.clk);
	@(posedge gpio_testbench.clk);

	
	getin(l1);

	
	gpio_testbench.gpio_mon.set_gpioeclk(1);
	@(posedge gpio_testbench.clk);
	@(posedge gpio_testbench.clk);
	gpio_testbench.gpio_mon.set_gpioeclk(0);
	@(posedge gpio_testbench.clk);
	@(posedge gpio_testbench.clk);

	
	getin(l2);

	
	
	
	
	

	if (l1 == r1 && l2 == r2)
		$write(".");
	else
		local_errs = local_errs + 1;
end
endtask




task test_simple;
reg [gw-1:0]		l1, l2, l3, l4;
integer		i, err;
begin
	$write("  Testing input mode ...");

	
	
	
	
	

	
	setctrl(0);

	err = 0;
	for (i = 0; i < 10 *  200; i = i +1) begin
		
		random_gpio(l1);
		gpio_testbench.gpio_mon.set_gpioin(l1);

		
		@(posedge gpio_testbench.clk);
		@(posedge gpio_testbench.clk);

		
		getin(l2);

		
		if (l1 != l2)
			err = err + 1;
	end

	
	
	
	
	if (!err)
		$display(" OK");
	else
		failed;

	$write("  Testing output mode ...");

	
	
	
	
	

	err = 0;
	for (i = 0; i < 10 *  200; i = i +1) begin
		
		l1 = $random;
		setout(l1);

		
		@(posedge gpio_testbench.clk);
		@(posedge gpio_testbench.clk);

		
		gpio_testbench.gpio_mon.get_gpioout(l2);

		
		if (l1 != l2)
			err = err + 1;
	end

	
	
	
	
	if (!err)
		$display(" OK");
	else
		failed;

	$write("  Testing bidirectional I/O ...");

	
	
	
	
	

	err = 0;
	for (i = 0; i < 10 *  200; i = i +1) begin
		
		l1 = $random;
		setoe(l1);

		
		@(posedge gpio_testbench.clk);
		@(posedge gpio_testbench.clk);

		
		gpio_testbench.gpio_mon.get_gpiooen(l2);

		
		if (l1 != ~l2)
			err = err + 1;
	end

	
	
	
	
	if (!err)
		$display(" OK");
	else
		failed;

	$write("  Testing auxiliary feature ...");

	
	
	
	
	

	err = 0;
	for (i = 0; i < 10 *  200; i = i +1) begin
		
		l1 = $random;
		gpio_testbench.gpio_mon.set_gpioaux(l1);

		
		l2 = $random;
		setaux(l2);

		
		l3 = $random;
		setout(l3);

		
		@(posedge gpio_testbench.clk);
		@(posedge gpio_testbench.clk);

		
		gpio_testbench.gpio_mon.get_gpioout(l4);

		
		
		
		if ((l1 & l2 | l3 & ~l2) != l4)
			err = err + 1;
	end

	
	
	
	
	if (!err)
		$display(" OK");
	else
		failed;

end
endtask




task test_ints;
integer		l1, l2, l3, l4;
integer		i, rnd, err;
integer		r1;
begin

	$write("  Testing control bit RGPIO_CTRL[INTE] and RGPIO_CTRL[INT] ...");

	
	
	
	
	

	
	ints_disabled = 0;

	err = 0;
	for( i = 0; i < 10 *  200; i = i + 1) begin

		
		r1 = ((1<< 31)-1) & 'hffffffff;
		gpio_testbench.gpio_mon.set_gpioin(r1);

		
		setptrig(0);
		
		
		setints(0);

		
		setctrl(1 <<  2);

		
		setinte(r1);

		
		@(posedge gpio_testbench.clk);
		@(posedge gpio_testbench.clk);

		
		l1 = gpio_testbench.gpio_top.wb_inta_o;

		
		gpio_testbench.gpio_mon.set_gpioin(0);

		
		@(posedge gpio_testbench.clk);
		@(posedge gpio_testbench.clk);
		@(posedge gpio_testbench.clk);

		
		l2 = gpio_testbench.gpio_top.wb_inta_o;

		
		setctrl(0);

		
		@(posedge gpio_testbench.clk);
		@(posedge gpio_testbench.clk);

		
		l3 = gpio_testbench.gpio_top.wb_inta_o;

		
		getints(l4);

		
		if (l1 || !l2 || l3 || (l4 != r1)) begin
			err = err +1;
		end
	end
		
	
	ints_disabled = 1;

	
	
	
	
	if (!err)
		$display(" OK");
	else
		failed;
end
endtask




task test_ptrig;
integer		l1, l2, l3;
integer		i, rnd, err;
integer		r1;
begin
	$write("  Testing ptrig features ...");

	
	
	
	
	

	
	ints_disabled = 0;

	err = 0;
	for( i = 0; i < 10 *  200; i = i + 1) begin

		
		r1 = ((1<< 31)-1) & 'hffffffff;

		
		gpio_testbench.gpio_mon.set_gpioin('h00000000);

		
		setints(0);

		
		setptrig('hffffffff);

		
		setctrl(1 <<  2);

		
		setinte(r1);

		
		@(posedge gpio_testbench.clk);
		@(posedge gpio_testbench.clk);

		
		l1 = gpio_testbench.gpio_top.wb_inta_o;

		
		gpio_testbench.gpio_mon.set_gpioin('hffffffff);

		
		@(posedge gpio_testbench.clk);
		@(posedge gpio_testbench.clk);
		@(posedge gpio_testbench.clk);

		
		l2 = gpio_testbench.gpio_top.wb_inta_o;

		
		setctrl(0);
		setints(0);

		
		@(posedge gpio_testbench.clk);
		@(posedge gpio_testbench.clk);

		
		l3 = gpio_testbench.gpio_top.wb_inta_o;

		
		if (l1 || !l2 || l3)
			err = err +1;
	end
		
	
	ints_disabled = 1;

	
	
	
	
	if (!err)
		$display(" OK");
	else
		failed;
end
endtask




always @(posedge gpio_testbench.gpio_top.wb_inta_o)
	if (ints_disabled) begin
		$display("Spurious interrupt detected. ");
		failed;
		ints_working = 9876;
		$display;
	end




integer 	i;
initial begin

	$dumpfile("../out/gpio_testbench.vcd");
	$dumpvars(0);

	nr_failed = 0;
	ints_disabled = 1;
	ints_working = 0;
	gpio_testbench.gpio_mon.set_gpioin(0);
	gpio_testbench.gpio_mon.set_gpioaux(0);
	gpio_testbench.gpio_mon.set_gpioeclk(0);
	$display;
	$display("###");
	$display("### GPIO IP Core Verification ###");
	$display("###");
	$display;
	$display("I. Testing correct operation of RGPIO_CTRL control bits");
	$display;


	$write("  Testing control bit RGPIO_CTRL[ECLK] ...");
	local_errs = 0;
	for (i = 0; i < 10 *  200; i = i + 1)
		test_eclk;
	if (local_errs == 0)
		$display(" OK");
	else
		failed;


	$write("  Testing control bit RGPIO_CTRL[NEC] ...");
	local_errs = 0;
	for (i = 0; i < 10 *  200; i = i + 1)
		test_nec;
	if (local_errs == 0)
		$display(" OK");
	else
		failed;

	test_ints;

	$display;
	$display("II. Testing modes of operation ...");
	$display;

	test_simple;
	test_ptrig;

	$display;
	$display("###");
	$display("### FAILED TESTS: %d ###", nr_failed);
	$display("###");
	$display;

  if ( nr_failed == 0 )
    begin
    $display ("report (%h)", 32'hdeaddead ) ;
    $display ("exit (00000000)" ) ;
    end
  else
    begin
    $display ("report (%h)", 32'heeeeeeee ) ;
    $display ("exit (00000000)" ) ;
    end
  $finish(0);

end

endmodule


`line 1 "\\Athron\verilog\gpio\gpio\bench\verilog\timescale.v"
`timescale 1ns/10ps



